From 20cb30fece958c2a29d09b5ae2a858e17348a188 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 13 2017 13:17:57 +0000
Subject: [PATCH 41/51] add checks for optional blocks


Add linter methods using @option, make them a prerequisite for methods
that need the optional block to exist and remove the now obsolete
boilerplate.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index b2fa084..596a579 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -444,6 +444,11 @@ class ModuleMDLinter(object):
         define it in other infrastructure tooling."""
         self.check_false('eol' in self.mmd)
 
+    @option
+    @prerequisite_for('dependencies_*')
+    def lint_dependencies_exists(self):
+        self.check('dependencies' in self.mmd)
+
     @error
     @guidelines_link('#Module_dependencies')
     @detail("The dependencies block must be a dictionary (key/value).")
@@ -451,15 +456,14 @@ class ModuleMDLinter(object):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
-        if 'dependencies' in self.mmd:
-            self.check_is_dict(self.mmd['dependencies'])
+        self.check_is_dict(self.mmd['dependencies'])
 
     @error
     @guidelines_link('#Module_dependencies')
     @detail("The 'buildrequires' dependencies block must be a dictionary"
             " (key/value).")
     @prerequisite('dependencies_dict')
-    def lint_buildrequires(self):
+    def lint_dependencies_buildrequires(self):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
@@ -470,7 +474,7 @@ class ModuleMDLinter(object):
     @detail("The 'buildrequires' dictionary must associate module name keys"
             " with stream name values.")
     @prerequisite('buildrequires')
-    def lint_buildrequires_items(self):
+    def lint_dependencies_buildrequires_items(self):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
@@ -482,7 +486,7 @@ class ModuleMDLinter(object):
     @detail("The 'requires' dependencies block must be a dictionary"
             " (key/value).")
     @prerequisite('dependencies')
-    def lint_requires(self):
+    def lint_dependencies_requires(self):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
@@ -493,20 +497,29 @@ class ModuleMDLinter(object):
     @detail("The 'requires' dictionary must associate module name keys with"
             " stream name values.")
     @prerequisite('requires')
-    def lint_requires_items(self):
+    def lint_dependencies_requires_items(self):
         """Modules MAY depend on other modules. These module relationships are
         listed in the dependencies block. Dependencies are expressed using
         module names and their stream names."""
         self.check_is_scalar(*self.mmd['dependencies']['requires'].values())
 
+    @option
+    @prerequisite_for('xmd_*')
+    def lint_xmd_exists(self):
+        self.check('xmd' in self.mmd)
+
     @error
     @guidelines_link('#Extensible_module_metadata_block')
     @detail("The 'xmd' block must be a dictionary (key/value).")
     def lint_xmd_dict(self):
         """Modules MAY also contain an extensible metadata block, a list of
         vendor-defined key-value pairs."""
-        if 'xmd' in self.mmd:
-            self.check_is_dict(self.mmd['xmd'])
+        self.check_is_dict(self.mmd['xmd'])
+
+    @option
+    @prerequisite_for('references_*')
+    def lint_references_exists(self):
+        self.check('references' in self.mmd)
 
     @error
     @guidelines_link('#Module_references')
@@ -515,8 +528,7 @@ class ModuleMDLinter(object):
         """Modules MAY define links referencing various upstream resources,
         such as community website, project documentation or upstream bug
         tracker."""
-        if 'references' in self.mmd:
-            self.check_is_dict(self.mmd['references'])
+        self.check_is_dict(self.mmd['references'])
 
     @warning
     @guidelines_link('#Module_references')
@@ -526,10 +538,8 @@ class ModuleMDLinter(object):
         """Modules MAY define links referencing various upstream resources,
         such as community website, project documentation or upstream bug
         tracker."""
-        if 'references' in self.mmd:
-            self.check(set(self.mmd['references']) <= {'community',
-                                                       'documentation',
-                                                       'tracker'})
+        self.check(set(self.mmd['references'])
+                   <= {'community', 'documentation', 'tracker'})
 
     @error
     @guidelines_link('#Module_references')
@@ -538,8 +548,12 @@ class ModuleMDLinter(object):
         """Modules MAY define links referencing various upstream resources,
         such as community website, project documentation or upstream bug
         tracker."""
-        if 'references' in self.mmd:
-            self.check_is_scalar(*self.mmd['references'].values())
+        self.check_is_scalar(*self.mmd['references'].values())
+
+    @option
+    @prerequisite_for('profiles_*')
+    def lint_profiles_exists(self):
+        self.check('profiles' in self.mmd)
 
     @error
     @guidelines_link('#Module_profiles')
@@ -548,31 +562,29 @@ class ModuleMDLinter(object):
         """The module author MAY define lists of packages that would be
         installed by default, and a minimum, when the module is enabled and the
         particular profile is selected."""
-        if 'profiles' in self.mmd:
-            self.check_is_dict(self.mmd['profiles'])
+        self.check_is_dict(self.mmd['profiles'])
 
     @info
     @guidelines_link('#Module_profiles')
     @detail("Modules that are supposed to be user-installable should in most"
             " cases have at least one profile.")
     @prerequisite('profiles_dict')
-    def lint_profiles_exist(self):
+    def lint_profiles_not_empty(self):
         """The module author MAY define lists of packages that would be
         installed by default, and a minimum, when the module is enabled and the
         particular profile is selected."""
-        self.check('profiles' in self.mmd and len(self.mmd['profiles']))
+        self.check(len(self.mmd['profiles']))
 
     @info
     @guidelines_link('#Module_profiles')
     @detail("Modules that are supposed to be user-installable should in most"
             " cases have a 'default' profile.")
-    @prerequisite('profiles_exist')
+    @prerequisite('profiles_dict')
     def lint_profiles_has_default(self):
         """The module author MAY define lists of packages that would be
         installed by default, and a minimum, when the module is enabled and the
         particular profile is selected."""
-        self.check('profiles' in self.mmd
-                   and 'default' in self.mmd['profiles'])
+        self.check('default' in self.mmd['profiles'])
 
     @error
     @guidelines_link('#Module_profiles')
@@ -582,8 +594,7 @@ class ModuleMDLinter(object):
         """The module author MAY define lists of packages that would be
         installed by default, and a minimum, when the module is enabled and the
         particular profile is selected."""
-        if 'profiles' in self.mmd:
-            self.check_is_dict(*self.mmd['profiles'].values())
+        self.check_is_dict(*self.mmd['profiles'].values())
 
     @warning
     @guidelines_link('#Module_API')
@@ -619,11 +630,10 @@ class ModuleMDLinter(object):
     @warning
     @guidelines_link('#Module_API')
     @detail("The list of API RPM packages is empty.")
-    @prerequisite('api_blocks_are_lists')
+    @prerequisite('api_keys', 'api_blocks_are_lists')
     def lint_api_rpms_empty(self):
         """Every module SHOULD define its public API."""
-        if 'rpms' in self.mmd['api']:
-            self.check(len(self.mmd['api']['rpms']) > 0)
+        self.check(len(self.mmd['api']['rpms']) > 0)
 
     @error
     @guidelines_link('#Module_API')
@@ -634,14 +644,18 @@ class ModuleMDLinter(object):
         for block in self.mmd['api'].values():
             self.check_is_scalar(*block)
 
+    @option
+    @prerequisite_for('filter_*')
+    def lint_filter_exists(self):
+        self.check('filter' in self.mmd)
+
     @error
     @guidelines_link('#Module_filters')
     @detail("The 'filter' block must be a dictionary (key/value).")
     def lint_filter_dict(self):
         """Module filters define lists of components or other content that
         should not be part of the resulting, composed module deliverable."""
-        if 'filter' in self.mmd:
-            self.check_is_dict(self.mmd['filter'])
+        self.check_is_dict(self.mmd['filter'])
 
     @warning
     @guidelines_link('#Module_filters')
@@ -651,8 +665,7 @@ class ModuleMDLinter(object):
         """Module filters define lists of components or other content that
         should not be part of the resulting, composed module deliverable.
         Currently the only supported type of filter are binary RPM packages."""
-        if 'filter' in self.mmd:
-            self.check(set(self.mmd['filter']) == {'rpms'})
+        self.check(set(self.mmd['filter']) == {'rpms'})
 
     @error
     @guidelines_link('#Module_filters')
@@ -661,8 +674,7 @@ class ModuleMDLinter(object):
     def lint_filter_blocks_are_lists(self):
         """Module filters define lists of components or other content that
         should not be part of the resulting, composed module deliverable."""
-        if 'filter' in self.mmd:
-            self.check_is_list(*self.mmd['filter'].values())
+        self.check_is_list(*self.mmd['filter'].values())
 
     @warning
     @guidelines_link('#Module_filters')
@@ -672,8 +684,7 @@ class ModuleMDLinter(object):
         """Module filters define lists of components or other content that
         should not be part of the resulting, composed module deliverable.
         Currently the only supported type of filter are binary RPM packages."""
-        if 'filter' in self.mmd and 'rpms' in self.mmd['filter']:
-            self.check(len(self.mmd['filter']['rpms']) > 0)
+        self.check(len(self.mmd['filter']['rpms']) > 0)
 
     @error
     @guidelines_link('#Module_filter')
@@ -682,9 +693,13 @@ class ModuleMDLinter(object):
     def lint_filter_blocks_items_are_scalar(self):
         """Module filters define lists of components or other content that
         should not be part of the resulting, composed module deliverable."""
-        if 'filter' in self.mmd:
-            for block in self.mmd['filter'].values():
-                self.check_is_scalar(*block)
+        for block in self.mmd['filter'].values():
+            self.check_is_scalar(*block)
+
+    @option
+    @prerequisite_for('components_*')
+    def lint_components_exists(self):
+        self.check('components' in self.mmd)
 
     @error
     @guidelines_link('#Module_components')
@@ -692,8 +707,7 @@ class ModuleMDLinter(object):
     def lint_components_dict(self):
         """Modules MAY, and most modules do contain a components block defining
         the module's content."""
-        if 'components' in self.mmd:
-            self.check_is_dict(self.mmd['components'])
+        self.check_is_dict(self.mmd['components'])
 
     @warning
     @guidelines_link('#Module_components')
@@ -704,8 +718,7 @@ class ModuleMDLinter(object):
         """Modules MAY, and most modules do contain a components block defining
         the module's content. RPM packages and other modules are the only
         currently supported content types."""
-        if 'components' in self.mmd:
-            self.check(set(self.mmd['components']) <= {'rpms', 'modules'})
+        self.check(set(self.mmd['components']) <= {'rpms', 'modules'})
 
     @error
     @guidelines_link('#Module_components')
@@ -714,8 +727,7 @@ class ModuleMDLinter(object):
     def lint_components_blocks_dict(self):
         """Modules MAY, and most modules do contain a components block defining
         the module's content."""
-        if 'components' in self.mmd:
-            self.check_is_dict(*self.mmd['components'].values())
+        self.check_is_dict(*self.mmd['components'].values())
 
     @error
     @guidelines_link('#Module_components')
@@ -724,10 +736,9 @@ class ModuleMDLinter(object):
     def lint_components_subblocks_dict(self):
         """Modules MAY, and most modules do contain a components block defining
         the module's content."""
-        if 'components' in self.mmd:
-            self.check_is_dict(*(subblock
-                                 for block in self.mmd['components'].values()
-                                 for subblock in block.values()))
+        self.check_is_dict(*(subblock
+                             for block in self.mmd['components'].values()
+                             for subblock in block.values()))
 
     @warning
     @guidelines_link('#Module_components')
@@ -736,8 +747,7 @@ class ModuleMDLinter(object):
     def lint_components_blocks_empty(self):
         """Modules MAY, and most modules do contain a components block defining
         the module's content."""
-        if 'components' in self.mmd:
-            self.check(all(self.mmd['components'].values()))
+        self.check(all(self.mmd['components'].values()))
 
     @warning
     @guidelines_link('#Module_components')
@@ -746,10 +756,9 @@ class ModuleMDLinter(object):
     def lint_components_subblocks_empty(self):
         """Modules MAY, and most modules do contain a components block defining
         the module's content."""
-        if 'components' in self.mmd:
-            self.check(all(subblock
-                           for block in self.mmd['components'].values()
-                           for subblock in block.values()))
+        self.check(all(subblock
+                       for block in self.mmd['components'].values()
+                       for subblock in block.values()))
 
     @error
     @guidelines_link('#Module_components')
@@ -757,11 +766,10 @@ class ModuleMDLinter(object):
     def lint_components_blocks_mandatory_keys(self):
         """Every component MUST declare why it was added to the module, its
         'rationale'."""
-        if 'components' in self.mmd:
-            for block in self.mmd['components'].values():
-                for subblock in self.mmd['components']['rpms'].values():
-                    self.check('rationale' in subblock)
-                    self.check_is_scalar(subblock['rationale'])
+        for block in self.mmd['components'].values():
+            for subblock in self.mmd['components']['rpms'].values():
+                self.check('rationale' in subblock)
+                self.check_is_scalar(subblock['rationale'])
 
     @error
     @guidelines_link('#Module_components')
@@ -772,9 +780,6 @@ class ModuleMDLinter(object):
     def lint_components_blocks_keys_types(self):
         """Modules MAY, and most modules do contain a components block defining
         the module's content."""
-        if 'components' not in self.mmd:
-            return
-
         for block in self.mmd['components'].values():
             for comp_md in block.values():
                 for k, v in comp_md.items():
@@ -795,6 +800,11 @@ class ModuleMDLinter(object):
                     for value in v:
                         self.check(isinstance(value, t))
 
+    @option
+    @prerequisite_for('components_rpms_*')
+    def lint_components_rpms_exists(self):
+        self.check('rpms' in self.mmd['components'])
+
     @warning
     @guidelines_link('#RPM_content')
     @detail("Recognized keys are: {}".format(
@@ -803,9 +813,13 @@ class ModuleMDLinter(object):
     def lint_components_rpms_recognized_keys(self):
         """Module RPM content is defined in the 'rpms' block of
         'components'."""
-        if 'rpms' in self.mmd.get('components', {}):
-            self.check(all(set(b) <= self.recognized_rpm_keys
-                           for b in self.mmd['components']['rpms'].values()))
+        self.check(all(set(b) <= self.recognized_rpm_keys
+                       for b in self.mmd['components']['rpms'].values()))
+
+    @option
+    @prerequisite_for('components_modules_*')
+    def lint_components_modules_exists(self):
+        self.check('modules' in self.mmd['components'])
 
     @warning
     @guidelines_link('#Module_content')
@@ -815,7 +829,6 @@ class ModuleMDLinter(object):
     def lint_components_modules_recognized_keys(self):
         """Including modules as content is defined in the 'modules' block of
         'components'."""
-        if 'modules' in self.mmd.get('components', {}):
-            self.check(
-                all(set(b) <= self.recognized_module_keys
-                    for b in self.mmd['components']['modules'].values()))
+        self.check(
+            all(set(b) <= self.recognized_module_keys
+                for b in self.mmd['components']['modules'].values()))

